VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit    'insist the all variables are declared before they are used

' the following structure needs to go in GENERAL DECLARATIONS at the very top of the project

Private Type RecordType    ' Define user-defined type.  vb.net equivalent is 'Structure'
    ID As Integer
    Name As String * 20
End Type


Private Sub Form_Load()


Dim MyRecord As RecordType, RecordNumber    ' Declare variables.
Dim LastRecordNumber As Integer
Dim foundit As Boolean
Dim i As Integer

' Open sample file for random access.

Open "c:\TESTFILE" For Random Shared As #1 Len = Len(MyRecord)

 'create 5 records
 
For i = 1 To 5
    MyRecord.ID = 1000 + i
    MyRecord.Name = "name" & CStr(i) & " Surname" & CStr(i)
    MsgBox "Creating record number " & i & " - " & MyRecord.Name
    Put #1, i, MyRecord
Next

RecordNumber = 4    ' Define record number.
Lock #1, RecordNumber    ' Lock record.
Get #1, RecordNumber, MyRecord    ' Read record.

MsgBox "Changing record 4"
MyRecord.ID = 234                 ' Modify record
MyRecord.Name = "John Smith"
Put #1, RecordNumber, MyRecord    ' Write modified record.

Unlock #1, RecordNumber    ' Unlock current record.

' add a record
' use a private function to get the last record number

LastRecordNumber = FindLastRecord(1, Len(MyRecord))
'parameter 1 =  1, the file handle
'paramter 2 = length of the type (this lets the function be re-used in any program with any TYPEs)

Seek #1, LastRecordNumber   ' go to end of file
MyRecord.ID = 999           ' create new record
MyRecord.Name = "New person"
Put #1, , MyRecord     'no record number given, so next one automatically used

MsgBox "Last record accessed in random file was number " & Loc(1)

' read all records starting from the last.

For RecordNumber = LastRecordNumber To 1 Step -1
    Seek #1, RecordNumber    ' Set position.
    Get #1, , MyRecord       ' Read record.  Note the record number is omitted!
    MsgBox "Person in record " & RecordNumber & " is " & MyRecord.Name
Next RecordNumber

'find a record
Seek #1, 1             ' go to start
foundit = False        ' flag when record is found

While Not EOF(1) And Not foundit   ' keep searching until file ends OR record is found
    Get #1, , MyRecord   ' get next record
    RecordNumber = Loc(1)          'find current recordnumber
    MsgBox "Looking for john smith in record " & RecordNumber
    
    'tip: force uppercase if the case of the string could vary
    'also need to trim because myrecord.name is padded with spaces up until its defined length!
    
    If Trim(UCase(MyRecord.Name)) = "JOHN SMITH" Then        'found it
        MsgBox "Found John Smith in record " & RecordNumber
        foundit = True   'set flag to show find was made so loop should end
        MyRecord.Name = "DELETED"  ' mark for deletion
        Put #1, RecordNumber, MyRecord     'update record
    Else
        MsgBox "Name in record " & RecordNumber & " (" & MyRecord.Name & ") is not john smith"
    End If
Wend

MsgBox "To summarise the state of play..."

LastRecordNumber = FindLastRecord(1, Len(MyRecord))
MsgBox "we have " & LastRecordNumber & " records"
    
For i = 1 To LastRecordNumber
    Get #1, i, MyRecord     ' read record
    MsgBox "Record " & i & " ID=" & MyRecord.ID & ", name=" & MyRecord.Name
Next

' to delete a record - write every other record to a new file

MsgBox "Deleting John Smith's record..."

Open "c:\NEWFILE" For Random Shared As #2 Len = Len(MyRecord)

Seek #1, 1       'rewind input file
RecordNumber = 1

' use my FindLastRecord function again to get number of last record

For i = 1 To FindLastRecord(1, Len(MyRecord))
    Get #1, i, MyRecord     ' read record
    
    If Trim(MyRecord.Name) <> "DELETED" Then                'to be kept
        MsgBox "Writing record" & i & "= " & MyRecord.Name
        Put #2, , MyRecord   'if record number is omitted, the next rec number is used
    Else
        MsgBox "NOT WRITING record " & i & " which is flagged for deletion!"
    End If

Next

' now close both files
Close

' so we can delete the original file...
Kill "c:\testfile"

' and rename the new file with the old one's name...
Name "c:\newfile" As "c:\testfile"

'reopen the changed file to prove it works...
Open "c:\TESTFILE" For Random Shared As #1 Len = Len(MyRecord)

MsgBox "To prove the new file has had the record deleted..."

LastRecordNumber = FindLastRecord(1, Len(MyRecord))
MsgBox "we now have " & LastRecordNumber & " records"
    
For i = 1 To LastRecordNumber
    Get #1, i, MyRecord     ' read record
    MsgBox "Record " & i & " ID=" & MyRecord.ID & ", name=" & MyRecord.Name
Next


MsgBox "Now deleting the testfile..."
Close 1
Kill "c:\testfile"
MsgBox "All Done! Closing down"

End

End Sub

Private Function FindLastRecord(filehandle As Integer, RecordLength As Integer)
    'file handle passed as a parameter
    ' \ is integer divide
    'put return value into variable name the same as the function
    
    FindLastRecord = LOF(filehandle) \ RecordLength    ' Get number of records in file.

End Function
